<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'department_id', 'association', 'phone', 'country', 'city',
        'website', 'status', 'status_p', 'role_id', 'image'
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function department()
    {
        # code...
        return $this->belongsTo(Department::class, 'department_id', 'id');
    }

    public function role()
    {
        # code...
        return $this->belongsTo(Role::class, 'role_id', 'id');
    }

    public function bills()
    {
        # code...
        return $this->hasMany(Bill::class, 'customer_id', 'id');
    }

    public function offers()
    {
        # code...
        return $this->hasMany(Offer::class, 'customer_id', 'id');
    }

    public function subscriptions()
    {
        # code...
        return $this->hasMany(Subscription::class, 'user_id', 'id');
    }

    public function permissions()
    {
        # code...
        $ids = [];
        if($this->role_id != 0){
            foreach($this->role->routes as $route){
                $ids[] = $route->id;
            }
        }
        return $ids;
    }
}
